﻿namespace EF_SQLite
{
    internal class Program
    {
        static void dodajPrzykładowyOsoby(BazaDanychOsób db)
        {
            Adres adres1 = new Adres
            {
                Miasto = "Toruń",
                Ulica = "Pod Mostem",
                NumerDomu = 1
            };

            Adres adres2 = new Adres
            {
                Miasto = "Toruń",
                Ulica = "Grudziądzka",
                NumerDomu = 5,
                NumerMieszkania = 477
            };

            Osoba osoba1 = new Osoba()
            {
                Imię = "Antoni",
                Nazwisko = "Gacek",
                NumerTelefonu = 123455678,
                Adres = adres1
            };

            Osoba osoba2 = new Osoba()
            {
                Imię = "Karol",
                Nazwisko = "Gacek",
                NumerTelefonu = 87653432,
                Adres = adres2
            };

            Osoba osoba3 = new Osoba()
            {
                Imię = "Witek",
                Nazwisko = "Gitek",
                NumerTelefonu = 33423423,
                Adres = adres1
            };

            db.DodajOsobę(osoba1);
            db.DodajOsobę(osoba2);
            db.DodajOsobę(osoba3);
        }

        static void pokażIdentyfikatoryOsób(BazaDanychOsób db)
        {
            string s = "Identyfikatory osób: ";
            foreach (int idOsoby in db.IdentyfikatoryOsób)
                s += idOsoby.ToString() + ", ";
            Console.WriteLine(s.Trim(' ', ';'));
        }

        static void pokażOsoby(BazaDanychOsób db)
        {
            foreach(int idOsoby in db.IdentyfikatoryOsób)
            {
                Console.WriteLine(db[idOsoby].ToString());
            }
        }

        static void Main(string[] args)
        {
            string dbName = "osoby.db";
            if (File.Exists(dbName)) File.Delete(dbName);

            BazaDanychOsób db = new BazaDanychOsób();
            pokażIdentyfikatoryOsób(db);

            //create
            dodajPrzykładowyOsoby(db);

            pokażIdentyfikatoryOsób(db);
            pokażOsoby(db);

            //delete
            int idUsuwanejOsoby = 2;
            Console.WriteLine($"Usuwam osobę nr {idUsuwanejOsoby}: {db.PobierzOsoba(idUsuwanejOsoby)}");
            db.UsuńOsobę(idUsuwanejOsoby);

            pokażIdentyfikatoryOsób(db);
            pokażOsoby(db);

            //update
            db[1] = new Osoba() 
            { 
                Imię = "Weronika", 
                Nazwisko = "Krasna", 
                NumerTelefonu = 1234567,
                Adres = new Adres() { Miasto = "Toruń", Ulica = "Grudziądzka", NumerDomu = 5, NumerMieszkania = 477 }
            };

            pokażIdentyfikatoryOsób(db);
            pokażOsoby(db);
        }
    }
}